## libstxxl 1.4.1

=== CMakeLists.txt ===
############################################################################
#  CMakeLists.txt
#
#  Base CMake file for building stxxl with different options.
#
#  Part of the STXXL. See http://stxxl.sourceforge.net
#
#  Copyright (C) 2013-2014 Timo Bingmann <tb@panthema.net>
#
#  Distributed under the Boost Software License, Version 1.0.
#  (See accompanying file LICENSE_1_0.txt or copy at
#  http://www.boost.org/LICENSE_1_0.txt)
############################################################################

set(CMAKE_LEGACY_CYGWIN_WIN32 0) # needed to silence warning on cygwin

# require cmake 2.6.2 (but please use 2.8.x)
cmake_minimum_required(VERSION 2.6.2 FATAL_ERROR)

# the STXXL project
project(stxxl)

# for additional cmake scripts
set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/misc/cmake)

# prohibit in-source builds
if("${PROJECT_SOURCE_DIR}" STREQUAL "${PROJECT_BINARY_DIR}")
  message(FATAL_ERROR "In-source builds are not allowed, use a separate build directory.")
endif()

# default to Debug building for single-config generators
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message("Defaulting CMAKE_BUILD_TYPE to Debug")
  set(CMAKE_BUILD_TYPE "Debug")
endif()

# STXXL version string
set(STXXL_VERSION_MAJOR "1")
set(STXXL_VERSION_MINOR "4")
set(STXXL_VERSION_PATCH "1")
set(STXXL_VERSION_STRING "${STXXL_VERSION_MAJOR}.${STXXL_VERSION_MINOR}.${STXXL_VERSION_PATCH}")
set(STXXL_VERSION_PHASE "prerelease/${CMAKE_BUILD_TYPE}")

# read git directory (if it exists) and find git sha
if(EXISTS ${PROJECT_SOURCE_DIR}/.git)
  find_package(Git)
  if(GIT_FOUND)
    execute_process(COMMAND ${GIT_EXECUTABLE} describe HEAD
      WORKING_DIRECTORY "${PROJECT_SOURCE_DIR}"
      OUTPUT_VARIABLE "STXXL_VERSION_GIT_REFSPEC"
      ERROR_QUIET
      OUTPUT_STRIP_TRAILING_WHITESPACE)
    execute_process(COMMAND ${GIT_EXECUTABLE} rev-parse HEAD
      WORKING_DIRECTORY "${PROJECT_SOURCE_DIR}"
      OUTPUT_VARIABLE "STXXL_VERSION_GIT_SHA1"
      ERROR_QUIET
      OUTPUT_STRIP_TRAILING_WHITESPACE)
    message(STATUS "Detected git refspec ${STXXL_VERSION_GIT_REFSPEC} sha ${STXXL_VERSION_GIT_SHA1}")
  endif()
endif()

###############################################################################
# compilation options

# please document all build options in doc/install.doc:install_build_options

option(BUILD_EXAMPLES "Build all stxxl examples" OFF)

option(BUILD_TESTS "Build all stxxl test programs" OFF)
if(BUILD_TESTS)
  set(BUILD_EXAMPLES ON)
endif()

option(BUILD_EXTRAS "Build all extra stxxl tests and tool programs" OFF)

if(MSVC_VERSION LESS 1700)
  # require boost for Visual C++ versions older than VC11 = MSVS 2012
  set(USE_BOOST ON)
else()
  option(USE_BOOST "Use Boost libraries for threads,config,filesystem,random and date_time" OFF)
endif()

if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
  option(USE_GNU_PARALLEL "Use GNU parallel extensions for multi-core parallelism" ON)
endif()

option(TRY_COMPILE_HEADERS "Test stxxl header files for self-sufficiency: try to compile them." OFF)

if(NOT MSVC)
  option(USE_STD_THREADS "Force usage of C++ standard library thread support." OFF)
endif()

option(NO_CXX11 "Build without C++11 flags" OFF)

option(USE_VALGRIND "Run tests with valgrind, pre-initialize some memory buffers." OFF)

option(USE_GCOV "Compile and run tests with gcov for coverage analysis." OFF)

# see tools/benchmarks about older TPIE benchmarks.
option(USE_TPIE "Try to compile extra benchmarks from the 2007 S&PE paper with an old TPIE version." OFF)

### building shared and/or static libraries

# by default we currently only build a static library, since we do not aim to
# keep a stable binary interface.
option(BUILD_STATIC_LIBS "Build static library version of libstxxl" ON)
option(BUILD_SHARED_LIBS "Build shared library version of libstxxl" OFF)

### allow user to specify other installation paths

set(INSTALL_BIN_DIR "bin" CACHE PATH "Installation directory for executables")
set(INSTALL_LIB_DIR "lib" CACHE PATH "Installation directory for libraries")
set(INSTALL_INCLUDE_DIR "include" CACHE PATH "Installation directory for header files")
set(INSTALL_PKGCONFIG_DIR "lib/pkgconfig" CACHE PATH "Installation directory for pkg-config file")

if(WIN32 AND NOT CYGWIN)
  set(DEF_INSTALL_CMAKE_DIR "CMake")
else()
  set(DEF_INSTALL_CMAKE_DIR "lib/cmake/stxxl")
endif()
set(INSTALL_CMAKE_DIR "${DEF_INSTALL_CMAKE_DIR}" CACHE PATH "Installation directory for cmake files")

###############################################################################
# enable use of "make test"

enable_testing()

include(CTest)
set(CTEST_PROJECT_NAME "STXXL")

if(USE_VALGRIND)
  set(STXXL_WITH_VALGRIND 1)
  set(VALGRIND_OPTS --leak-check=full --error-exitcode=1 --suppressions=${PROJECT_SOURCE_DIR}/misc/valgrind.supp)
endif()

###############################################################################
# enable use of "make package"

# general package settings
set(CPACK_PACKAGE_VENDOR "STXXL Maintainer Team")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Library of external memory algorithms")
set(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/README")
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE_1_0.txt")
set(CPACK_PACKAGE_VERSION_MAJOR "${STXXL_VERSION_MAJOR}")
set(CPACK_PACKAGE_VERSION_MINOR "${STXXL_VERSION_MINOR}")
set(CPACK_PACKAGE_VERSION_PATCH "${STXXL_VERSION_PATCH}")

# source packaging
set(CPACK_SOURCE_GENERATOR "TGZ")
set(CPACK_SOURCE_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
set(CPACK_SOURCE_IGNORE_FILES "/\\\\..*$;/build;${CPACK_SOURCE_IGNORE_FILES}")

# binary packaging
set(CPACK_GENERATOR "TGZ")

include(CPack)

###############################################################################
# check platform

if(WIN32 OR WIN64 OR MINGW)
  set(STXXL_WINDOWS "1")
endif()

if(MSVC)
  set(STXXL_MSVC ${MSVC_VERSION})
endif()

###############################################################################
# enable warnings

if(MSVC)
  # Force to always compile with W4
  if(CMAKE_CXX_FLAGS MATCHES "/W[0-4]")
    string(REGEX REPLACE "/W[0-4]" "/W4" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
  else()
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W4")
  endif()
  ### disable verbose warnings:
  # warning C4127: conditional expression is constant
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4127")
  # warning C4290: C++ exception specification ignored except to indicate a function is not __declspec(nothrow)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4290")
  # warning C4250: '...' : inherits '...' via dominance
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4250")
  # warning C4512: assignment operator could not be generated (contains const members)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4512")
  # warning C4355: 'this' : used in base member initializer list
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4355")
  # disable lots of warnings about "unsecure" C runtime function
  add_definitions(-D_CRT_SECURE_NO_WARNINGS)
  # disable lots of warnings about deprecated POSIX function names
  add_definitions(-D_CRT_NONSTDC_NO_DEPRECATE)
  # disable lots of warnings about "unsecure" STL functions
  add_definitions(-D_SCL_SECURE_NO_WARNINGS)
else()
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -W -Wall -pedantic -Wno-long-long")
  # detect -Wextra
  include(CheckCXXCompilerFlag)
  check_cxx_compiler_flag(-Wextra CXX_HAS_FLAGS_WEXTRA)
  if(CXX_HAS_FLAGS_WEXTRA)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wextra")
  endif()
endif()

###############################################################################
# enable C++11 and more compiler features

# more template depth for some tests and compilers
include(CheckCXXCompilerFlag)
check_cxx_compiler_flag(-ftemplate-depth=1024 CXX_HAS_TEMPLATE_DEPTH)
if(CXX_HAS_TEMPLATE_DEPTH)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -ftemplate-depth=1024")
endif()

# enable C++11
if(MSVC)
  # MSVC 11 or greater has C++11 automatically enabled
elseif(CYGWIN)
  # C++11 is very restrictive on Cygwin
elseif(NOT NO_CXX11)
  # try -std= flags to enable C++11
  check_cxx_compiler_flag(-std=c++11 CXX_HAS_STD_CXX11)
  if(CXX_HAS_STD_CXX11)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
  else()
    check_cxx_compiler_flag(-std=c++0x CXX_HAS_STD_CXX0X)
    if(CXX_HAS_STD_CXX0X)
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
    endif()
  endif()
  # on MacOSX with clang we need to use libc++ for C++11 headers
  if(APPLE)
    if (CMAKE_CXX_COMPILER MATCHES ".*clang[+][+]"
        OR CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
      check_cxx_compiler_flag(-stdlib=libc++ CXX_HAS_STDLIB_LIBCXX)
      if(CXX_HAS_STDLIB_LIBCXX)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")
      else()
        message(SEND_ERROR "Compilation on MacOSX with clang requires libc++.")
      endif()
    endif()
  endif(APPLE)
endif()

# check C++ compiler for C++11 features

include(CheckCXXSourceCompiles)
check_cxx_source_compiles(
  "#include <vector>
  int main() { std::vector<int> v(42); for (auto i : v) { ++i; } return 0; }"
  STXXL_HAVE_CXX11_RANGE_FOR_LOOP)

###############################################################################
# enable gcov coverage analysis with gcc

if(USE_GCOV)
  # find programs
  find_program(GENHTML genhtml)
  find_program(LCOV lcov)

  if(NOT LCOV OR NOT GENHTML)
    message(SEND_ERROR "Coverage analysis requires lcov and genhtml programs.")
  endif()

  # add coverage anaylsis compile and link flags
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fprofile-arcs -ftest-coverage")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fprofile-arcs -ftest-coverage")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -lgcov")

  # add cached variable containing parameters for lcov/genhtml
  set(LCOV_FLAGS "" CACHE STRING "parameters for lcov")
  set(GENHTML_FLAGS --legend --no-branch-coverage
    CACHE STRING "parameters for genhtml")

  # custom target to run before tests
  add_custom_target(lcov-reset
    COMMAND ${LCOV} -q --directory ${CMAKE_BINARY_DIR} --zerocounters
    COMMENT "Resetting code coverage counters")

  # custom lcov target to run tests
  add_custom_target(lcov-runtests
    COMMAND ${CMAKE_CTEST_COMMAND} \${ARGS}
    DEPENDS ${ALL_TESTS} lcov-reset
    COMMENT "Running all unit tests")

  # get git version description
  execute_process(COMMAND git describe --tags
    WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
    OUTPUT_VARIABLE GITDESC
    OUTPUT_STRIP_TRAILING_WHITESPACE)

  # command sequence to gather, clean and generate HTML coverage report
  add_custom_target(lcov-html
    COMMAND ${LCOV} -q --directory . --capture --output-file lcov.info
    COMMAND ${LCOV} -q --remove lcov.info '/usr/*' ${LCOV_FLAGS} --output-file lcov-clean.info
    COMMAND ${GENHTML} -q -o coverage --title "STXXL ${GITDESC}" --prefix ${PROJECT_SOURCE_DIR} ${GENHTML_FLAGS} lcov-clean.info
    COMMENT "Capturing code coverage counters and create HTML coverage report"
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR})

  # top-level target to run tests and generate coverage report
  add_custom_target(test-coverage
    COMMENT "Generate HTML coverage report "
    DEPENDS lcov-runtests lcov-html)

endif(USE_GCOV)

###############################################################################
# find thread and random library

# for testing for c++ system include files
include(CheckIncludeFileCXX)

check_include_file_cxx(pthread.h HAVE_PTHREAD_H)

if(MINGW AND NOT HAVE_PTHREAD_H)
  set(USE_STD_THREADS ON)
endif()

if(MSVC OR USE_STD_THREADS)

  # check for std::mutex and std::threads avalability
  check_cxx_source_compiles(
    "#include <mutex>
    int main() { std::mutex mutex; mutex.lock(); return 0; }"
    HAVE_STD_MUTEX)

  check_cxx_source_compiles(
    "#include <thread>
    int main() { std::thread t; return 0; }"
    HAVE_STD_THREAD)

  if(HAVE_STD_THREAD AND HAVE_STD_MUTEX)
    set(STXXL_STD_THREADS "1")
  else()
    set(USE_BOOST ON)

=== examples/CMakeLists.txt ===
############################################################################
#  examples/CMakeLists.txt
#
#  Part of the STXXL. See http://stxxl.sourceforge.net
#
#  Copyright (C) 2013 Timo Bingmann <tb@panthema.net>
#
#  Distributed under the Boost Software License, Version 1.0.
#  (See accompanying file LICENSE_1_0.txt or copy at
#  http://www.boost.org/LICENSE_1_0.txt)
############################################################################

add_subdirectory(algo)
add_subdirectory(applications)
add_subdirectory(common)
add_subdirectory(containers)
add_subdirectory(stream)

=== lib/CMakeLists.txt ===
############################################################################
#  lib/CMakeLists.txt
#
#  CMake file for libstxxl.a/so/lib
#
#  Part of the STXXL. See http://stxxl.sourceforge.net
#
#  Copyright (C) 2013 Timo Bingmann <tb@panthema.net>
#
#  Distributed under the Boost Software License, Version 1.0.
#  (See accompanying file LICENSE_1_0.txt or copy at
#  http://www.boost.org/LICENSE_1_0.txt)
############################################################################

set(LIBSTXXL_SOURCES

  common/cmdline.cpp
  common/exithandler.cpp
  common/log.cpp
  common/rand.cpp
  common/seed.cpp
  common/utils.cpp
  common/verbose.cpp
  common/version.cpp

  io/boostfd_file.cpp
  io/create_file.cpp
  io/disk_queued_file.cpp
  io/file.cpp
  io/fileperblock_file.cpp
  io/iostats.cpp
  io/mem_file.cpp
  io/request.cpp
  io/request_queue_impl_1q.cpp
  io/request_queue_impl_qwqr.cpp
  io/request_queue_impl_worker.cpp
  io/request_with_state.cpp
  io/request_with_waiters.cpp
  io/serving_request.cpp
  io/syscall_file.cpp
  io/ufs_file_base.cpp
  io/wbtl_file.cpp
  io/wfs_file_base.cpp
  io/wincall_file.cpp

  mng/block_manager.cpp
  mng/config.cpp
  mng/disk_allocator.cpp

  algo/async_schedule.cpp

  )

if(NOT MSVC)
  # additional sources for non Visual Studio builds
  set(LIBSTXXL_SOURCES ${LIBSTXXL_SOURCES}
    io/mmap_file.cpp
    io/simdisk_file.cpp
    )
endif(NOT MSVC)

if(STXXL_HAVE_LINUXAIO_FILE)
  # additional sources fo LinuxAIO fileio access method
  set(LIBSTXXL_SOURCES ${LIBSTXXL_SOURCES}
    io/linuxaio_file.cpp
    io/linuxaio_queue.cpp
    io/linuxaio_request.cpp
    )
endif()

# tell top-level cmakelists which library we build
set(STXXL_EXPORTED_LIBS stxxl)

# we name debug library builds "stxxl_debug" and release builds "stxxl"
string(TOLOWER "stxxl_${CMAKE_BUILD_TYPE}" STXXL_LIBNAME)
if(STXXL_LIBNAME STREQUAL "stxxl_release" OR STXXL_LIBNAME STREQUAL "stxxl_")
  set(STXXL_LIBNAME "stxxl")
endif()

if(BUILD_SHARED_LIBS)

  # build stxxl SHARED library and link all programs again it
  add_library(stxxl SHARED ${LIBSTXXL_SOURCES})
  set_target_properties(stxxl PROPERTIES OUTPUT_NAME "${STXXL_LIBNAME}")
  set_target_properties(stxxl PROPERTIES VERSION "${STXXL_VERSION_STRING}")
  install(TARGETS stxxl
    EXPORT stxxl-targets
    ARCHIVE DESTINATION ${INSTALL_LIB_DIR}
    LIBRARY DESTINATION ${INSTALL_LIB_DIR})

  if(BUILD_STATIC_LIBS)
    # but also build STATIC library
    add_library(stxxl_static STATIC ${LIBSTXXL_SOURCES})
    set_target_properties(stxxl_static PROPERTIES OUTPUT_NAME "${STXXL_LIBNAME}")
    set_target_properties(stxxl_static PROPERTIES VERSION "${STXXL_VERSION_STRING}")
    install(TARGETS stxxl_static
      EXPORT stxxl-targets
      ARCHIVE DESTINATION ${INSTALL_LIB_DIR})

    # we build both shared and static, export both
    set(STXXL_EXPORTED_LIBS stxxl stxxl_static)
  endif()

else()

  if(NOT BUILD_STATIC_LIBS)
    message(FATAL_ERROR "You must build either a static or shared STXXL library")
  endif()

  # build stxxl STATIC library and link all programs again it
  add_library(stxxl STATIC ${LIBSTXXL_SOURCES})
  set_target_properties(stxxl PROPERTIES OUTPUT_NAME "${STXXL_LIBNAME}")
  set_target_properties(stxxl PROPERTIES VERSION "${STXXL_VERSION_STRING}")
  install(TARGETS stxxl
    EXPORT stxxl-targets
    ARCHIVE DESTINATION ${INSTALL_LIB_DIR}
    LIBRARY DESTINATION ${INSTALL_LIB_DIR})

endif()

# export variables to top-level cmakelists
set(STXXL_LIBNAME ${STXXL_LIBNAME} PARENT_SCOPE)
set(STXXL_EXPORTED_LIBS ${STXXL_EXPORTED_LIBS} PARENT_SCOPE)

=== local/CMakeLists.txt ===
############################################################################
#  local/CMakeLists.txt
#
#  CMake file which compiles and links all .cpp files in local/ with STXXL.
#
#  Part of the STXXL. See http://stxxl.sourceforge.net
#
#  Copyright (C) 2013 Timo Bingmann <tb@panthema.net>
#
#  Distributed under the Boost Software License, Version 1.0.
#  (See accompanying file LICENSE_1_0.txt or copy at
#  http://www.boost.org/LICENSE_1_0.txt)
############################################################################

# find all .cpp files in current directory
file(GLOB source_files RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "*.cpp")

# compile and link
foreach(file ${source_files})
  # remove .cpp
  string(REGEX REPLACE "\\.cpp$" "" file ${file})
  # call macro
  stxxl_build_tool(${file})
endforeach()

=== tests/CMakeLists.txt ===
############################################################################
#  tests/CMakeLists.txt
#
#  Part of the STXXL. See http://stxxl.sourceforge.net
#
#  Copyright (C) 2013 Timo Bingmann <tb@panthema.net>
#
#  Distributed under the Boost Software License, Version 1.0.
#  (See accompanying file LICENSE_1_0.txt or copy at
#  http://www.boost.org/LICENSE_1_0.txt)
############################################################################

add_subdirectory(algo)
add_subdirectory(common)
add_subdirectory(containers)
add_subdirectory(io)
add_subdirectory(mng)
add_subdirectory(stream)

=== tools/CMakeLists.txt ===
############################################################################
#  tools/CMakeLists.txt
#
#  Part of the STXXL. See http://stxxl.sourceforge.net
#
#  Copyright (C) 2013 Timo Bingmann <tb@panthema.net>
#
#  Distributed under the Boost Software License, Version 1.0.
#  (See accompanying file LICENSE_1_0.txt or copy at
#  http://www.boost.org/LICENSE_1_0.txt)
############################################################################

stxxl_build_tool(stxxl_tool
  create_files.cpp
  benchmark_disks.cpp
  benchmark_files.cpp
  benchmark_sort.cpp
  benchmark_disks_random.cpp
  benchmark_pqueue.cpp
  mlock.cpp
  mallinfo.cpp
  )

install(TARGETS stxxl_tool RUNTIME DESTINATION ${INSTALL_BIN_DIR})

add_subdirectory(benchmarks)
add_subdirectory(extras)

=== examples/algo/CMakeLists.txt ===
############################################################################
#  examples/algo/CMakeLists.txt
#
#  Part of the STXXL. See http://stxxl.sourceforge.net
#
#  Copyright (C) 2013 Timo Bingmann <tb@panthema.net>
#
#  Distributed under the Boost Software License, Version 1.0.
#  (See accompanying file LICENSE_1_0.txt or copy at
#  http://www.boost.org/LICENSE_1_0.txt)
############################################################################

stxxl_build_example(copy_and_sort_file)
stxxl_build_example(phonebills)
stxxl_build_example(phonebills_genlog)
stxxl_build_example(sort_file)

=== examples/applications/CMakeLists.txt ===
############################################################################
#  examples/applications/CMakeLists.txt
#
#  Part of the STXXL. See http://stxxl.sourceforge.net
#
#  Copyright (C) 2013 Timo Bingmann <tb@panthema.net>
#
#  Distributed under the Boost Software License, Version 1.0.
#  (See accompanying file LICENSE_1_0.txt or copy at
#  http://www.boost.org/LICENSE_1_0.txt)
############################################################################

if(NOT CYGWIN AND NOT MINGW) #-tb too big to build on cygwin

  stxxl_build_example(skew3)

  if(MSVC AND BUILD_TESTS)
    # requires /bigobj flag to build
    set_target_properties(skew3 PROPERTIES COMPILE_FLAGS /bigobj)
  endif()

  stxxl_test(skew3 --size 1mib random --check)

endif()

=== examples/common/CMakeLists.txt ===
############################################################################
#  examples/common/CMakeLists.txt
#
#  Part of the STXXL. See http://stxxl.sourceforge.net
#
#  Copyright (C) 2013 Timo Bingmann <tb@panthema.net>
#
#  Distributed under the Boost Software License, Version 1.0.
#  (See accompanying file LICENSE_1_0.txt or copy at
#  http://www.boost.org/LICENSE_1_0.txt)
############################################################################

stxxl_build_example(cmdline)

stxxl_test(cmdline test)

=== examples/containers/CMakeLists.txt ===
############################################################################
#  examples/containers/CMakeLists.txt
#
#  Part of the STXXL. See http://stxxl.sourceforge.net
#
#  Copyright (C) 2013-2014 Timo Bingmann <tb@panthema.net>
#
#  Distributed under the Boost Software License, Version 1.0.
#  (See accompanying file LICENSE_1_0.txt or copy at
#  http://www.boost.org/LICENSE_1_0.txt)
############################################################################

stxxl_build_example(copy_file)
stxxl_build_example(deque1)
stxxl_build_example(deque2)
stxxl_build_example(map1)
stxxl_build_example(matrix1)
stxxl_build_example(pqueue1)
stxxl_build_example(pqueue2)
stxxl_build_example(queue1)
stxxl_build_example(queue2)
stxxl_build_example(sequence1)
stxxl_build_example(sorter1)
stxxl_build_example(sorter2)
stxxl_build_example(stack1)
stxxl_build_example(stack2)
stxxl_build_example(unordered_map1)
stxxl_build_example(vector1)
stxxl_build_example(vector2)
stxxl_build_example(vector_buf)

stxxl_test(deque1)
stxxl_test(deque2)
stxxl_test(map1)
stxxl_test(matrix1)
stxxl_test(pqueue1)
stxxl_test(pqueue2)
stxxl_test(queue1)
stxxl_test(queue2)
stxxl_test(sequence1)
stxxl_test(sorter1)
stxxl_test(sorter2)
stxxl_test(stack1)
stxxl_test(stack2)
stxxl_test(unordered_map1)
stxxl_test(vector1)
stxxl_test(vector2)
stxxl_test(vector_buf)

=== examples/stream/CMakeLists.txt ===
############################################################################
#  examples/stream/CMakeLists.txt
#
#  Part of the STXXL. See http://stxxl.sourceforge.net
#
#  Copyright (C) 2013 Timo Bingmann <tb@panthema.net>
#
#  Distributed under the Boost Software License, Version 1.0.
#  (See accompanying file LICENSE_1_0.txt or copy at
#  http://www.boost.org/LICENSE_1_0.txt)
############################################################################

stxxl_build_example(stream1)

stxxl_test(stream1)

=== tests/algo/CMakeLists.txt ===
############################################################################
#  tests/algo/CMakeLists.txt
#
#  Part of the STXXL. See http://stxxl.sourceforge.net
#
#  Copyright (C) 2013 Timo Bingmann <tb@panthema.net>
#
#  Distributed under the Boost Software License, Version 1.0.
#  (See accompanying file LICENSE_1_0.txt or copy at
#  http://www.boost.org/LICENSE_1_0.txt)
############################################################################

stxxl_build_test(test_asch)
stxxl_build_test(test_bad_cmp)
stxxl_build_test(test_ksort)
stxxl_build_test(test_random_shuffle)
stxxl_build_test(test_scan)
stxxl_build_test(test_sort)
stxxl_build_test(test_stable_ksort)

add_define(test_bad_cmp "STXXL_VERBOSE_LEVEL=0")
add_define(test_ksort "STXXL_VERBOSE_LEVEL=1" "STXXL_CHECK_ORDER_IN_SORTS")
add_define(test_random_shuffle "STXXL_VERBOSE_LEVEL=0")
add_define(test_sort "STXXL_VERBOSE_LEVEL=0")

stxxl_test(test_asch 3 100 1000 42)
stxxl_test(test_bad_cmp 16)
stxxl_test(test_ksort)
stxxl_test(test_random_shuffle)
stxxl_test(test_scan)
stxxl_test(test_sort)
stxxl_test(test_stable_ksort)

if(NOT CYGWIN AND NOT MINGW) #-tb too big to build on cygwin

  stxxl_build_test(test_ksort_all_parameters)
  stxxl_build_test(test_stable_ksort_all_parameters)
  stxxl_build_test(test_sort_all_parameters)

  add_define(test_ksort_all_parameters "STXXL_VERBOSE_STABLE_KSORT=STXXL_VERBOSE0" "STXXL_VERBOSE_LEVEL=0" "STXXL_CHECK_ORDER_IN_SORTS")

  if(MSVC AND BUILD_TESTS)
    # requires /bigobj flag to build
    set_target_properties(test_ksort_all_parameters PROPERTIES COMPILE_FLAGS /bigobj)
    set_target_properties(test_sort_all_parameters PROPERTIES COMPILE_FLAGS /bigobj)
    set_target_properties(test_stable_ksort_all_parameters PROPERTIES COMPILE_FLAGS /bigobj)
  endif()

  ### extra sort tests:
  #test_sort_all_parameters         <MiB to sort> <MiB to use> <alloc_strategy [0..3]> <blk_size [0..14]> <seed>
  #test_ksort_all_parameters        <MiB to sort> <MiB to use> <alloc_strategy [0..3]> <blk_size [0..14]> <seed>
  #test_stable_ksort_all_parameters <MiB to sort> <MiB to use> <alloc_strategy [0..3]> <blk_size [0..14]> <seed>
  foreach(DATA 1024)
    foreach(RAM 384)
      foreach(STRATEGY 0 1 2 3)
        foreach(BLK_SIZE 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14)

          stxxl_extra_test(test_sort_all_parameters ${DATA} ${RAM} ${STRATEGY} ${BLK_SIZE} 42)
          stxxl_extra_test(test_ksort_all_parameters ${DATA} ${RAM} ${STRATEGY} ${BLK_SIZE} 42)
          #-tb not fully implemented
          #stxxl_extra_test(test_stable_ksort_all_parameters ${DATA} ${RAM} ${STRATEGY} ${BLK_SIZE} 42)

        endforeach(BLK_SIZE)
      endforeach(STRATEGY)
    endforeach(RAM)
  endforeach(DATA)

  if(NOT BUILD_EXTRAS)

    foreach(STRATEGY 0 1 2 3)
      stxxl_test(test_sort_all_parameters 512 192 ${STRATEGY} 10 42)
      stxxl_test(test_ksort_all_parameters 512 192 ${STRATEGY} 10 42)
      #-tb not fully implemented
      #stxxl_test(test_stable_ksort_all_parameters 512 192 ${STRATEGY} 10 42)
    endforeach(STRATEGY)

  endif(NOT BUILD_EXTRAS)

endif()

if(USE_GNU_PARALLEL)

  stxxl_build_test(test_parallel_sort)

  ### parallel sort tests
  #algo/test_parallel_sort [n in MiB] [p threads] [M in MiB] [sorting algorithm: m | q | qb | s] [merging algorithm: p | s | n]
  foreach(DATA 768)
    foreach(RAM 128)
      foreach(THREADS 1 2 3 4)
        foreach(SORT m q qb s)
          foreach(MERGE p s n)
            stxxl_extra_test(test_parallel_sort ${DATA} ${THREADS} ${RAM} ${SORT} ${MERGE})
          endforeach(MERGE)
        endforeach(SORT)
      endforeach(THREADS)
    endforeach(RAM)
  endforeach(DATA)

  if(NOT BUILD_EXTRAS)

    foreach(SORT m q qb s)
      foreach(MERGE p s n)
        stxxl_test(test_parallel_sort 256 4 96 ${SORT} ${MERGE})
      endforeach(MERGE)
    endforeach(SORT)

  endif(NOT BUILD_EXTRAS)

endif(USE_GNU_PARALLEL)

=== debian/changelog ===
libstxxl (1.4.1-6) unstable; urgency=medium

  * No changes upload.

 -- Anton Gladky <gladk@debian.org>  Fri, 10 Oct 2025 21:40:31 +0200

libstxxl (1.4.1-5) unstable; urgency=medium

  [ Debian Janitor ]
  * [ecf9a24] Apply multi-arch hints. + libstxxl-doc: Add Multi-Arch: foreign.

  [ Anton Gladky ]
  * [60d0282] Update changelog.
  * [63bd569] fix(debian): Raise minimal CMake version (Closes: #1113207)
  * [839192a] chore(debian): Update Standards-Version to 4.7.2

 -- Anton Gladky <gladk@debian.org>  Thu, 09 Oct 2025 21:13:09 +0200

libstxxl (1.4.1-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062642

 -- Graham Inggs <ginggs@debian.org>  Wed, 28 Feb 2024 19:09:19 +0000

libstxxl (1.4.1-4) unstable; urgency=medium

  * [fe2eba4] Add .gitlab-ci.yml.
  * [3c8b84c] Disable pdf build. (Closes: #1051165)
  * [6a530dc] Trim trailing whitespace.
  * [2bf9fcd] Update watch file format version to 4.
  * [aeff07a] Bump debhelper from old 11 to 13.
  * [48b1e14] Set debhelper-compat version in Build-Depends.
  * [0151f9e] Fix day-of-week for changelog entry 1.3.1-4.
  * [2aa4f8a] Remove field Priority on binary packages
              libstxxl-dev, libstxxl-doc, libstxxl1-bin that duplicates source.
  * [7ec46e6] Set Recommends-Versions to 4.6.2.
  * [5ccf28b] Apply cme fix dpkg.
  * [45b9d3f] Add myself as uploader.

 -- Anton Gladky <gladk@debian.org>  Fri, 15 Sep 2023 19:36:33 +0200

libstxxl (1.4.1-3) unstable; urgency=medium

  * Team upload.
  * [973f16b] Switch to compat level 11
  * [76a40a5] Update VCS-fields
  * [d0e648e] Remove outdated Testsuite-field
  * [c26df19] Set Standards-Version: 4.1.3
  * [8973044] Apply cme fix dpkg
  * [c3b6b0a] Replace priority extra by optional
  * [832b6c2] Drop dbg-package
  * [de76517] Remove myself from uploaders

 -- Anton Gladky <gladk@debian.org>  Thu, 08 Mar 2018 21:01:26 +0100

libstxxl (1.4.1-2) unstable; urgency=medium

  [ Anton Gladky ]
  * [10bbced] Apply cme fix dpkg-control.
  * [2da8441] Add a description to patch.
  * [c9f296e] Remove unneded lintian-overrides.
  * [23d7673] Rename shared lib due to GCC-5 transition. (Closes: #791173)
  * [0105031] Use DEP-5 for d/copyright.

  [ Bas Couwenberg ]
  * Use versioned Breaks/Replaces.

 -- Anton Gladky <gladk@debian.org>  Sun, 23 Aug 2015 17:00:29 +0200

libstxxl (1.4.1-1) unstable; urgency=medium

  [ D Haley ]
  * [7d8f358] Imported Upstream version 1.4.1
  * [69811b5] Refresh patches
  * [d8eca54] Update standards version

  [ Anton Gladky ]
  * [066a810] Fix bugnumber.
  * [5e7edbb] Remove timestamp from HTML doxygen build.

 -- Anton Gladky <gladk@debian.org>  Sun, 17 May 2015 22:18:32 +0200

=== debian/control ===
Source: libstxxl
Standards-Version: 4.7.2
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 D Haley <mycae@gmx.com>,
 Anton Gladky <gladk@debian.org>,
Section: science
Priority: optional
Build-Depends:
 dpkg-dev (>= 1.22.5),
 cmake,
 debhelper-compat (= 13),
 doxygen,
 doxygen-latex,
 ghostscript,
 graphviz,
 texlive-fonts-extra,
 texlive-fonts-recommended,
 texlive-latex-extra,
 texlive-latex-recommended,
Vcs-Browser: https://salsa.debian.org/science-team/libstxxl
Vcs-Git: https://salsa.debian.org/science-team/libstxxl.git
Homepage: http://stxxl.sourceforge.net

Package: libstxxl-dev
Architecture: any
Section: libdevel
Depends:
 libstxxl1t64 (= ${binary:Version}),
 ${misc:Depends},
Suggests:
 libstxxl-doc,
Description: Development libraries for STXXL
 STXXL provides an STL replacement using an abstraction layer to
 storage devices to allow for the optimal layout of data structures. This
 allows for multi-terabyte datasets to be held and manipulated in standard
 C++ data structures, whilst abstracting the complexity of managing this
 behaviour efficiently. STXXL utilises multi-disk I/O to speed up
 I/O bound calculations. STXXL has been developed at the University
 of Karlsruhe.
 .
 Development libraries for STXXL, required for building programs that
 utilise the STXXL library

Package: libstxxl-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends:
 ${misc:Depends},
 libjs-jquery,
Description: Documentation for STXXL
 STXXL provides an STL replacement using an abstraction layer to
 storage devices to allow for the optimal layout of data structures. This
 allows for multi-terabyte datasets to be held and manipulated in standard
 C++ data structures, whilst abstracting the complexity of managing this
 behaviour efficiently. STXXL utilises multi-disk I/O to speed up
 I/O bound calculations. STXXL has been developed at the University
 of Karlsruhe.
 .
 Documentation for the STXXL library.

Package: libstxxl1t64
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 libstxxl1v5 (<< ${source:Version}),
 libstxxl1 (<< 1.4.1-2~),
Provides:
 ${t64:Provides},
Replaces:
 libstxxl1v5,
 libstxxl1 (<< 1.4.1-2~),
Description: C++ Standard Template Library for extra large datasets
 STXXL provides an STL replacement using an abstraction layer to
 storage devices to allow for the optimal layout of data structures. This
 allows for multi-terabyte datasets to be held and manipulated in standard
 C++ data structures, whilst abstracting the complexity of managing this
 behaviour efficiently. STXXL utilises multi-disk I/O to speed up
 I/O bound calculations. STXXL has been developed at the University
 of Karlsruhe.
X-Time64-Compat: libstxxl1v5

Package: libstxxl1-bin
Architecture: any
Section: misc
Depends:
 libstxxl1t64 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: STXXL File creation and benchmark tool
 STXXL provides an STL replacement using an abstraction layer to
 storage devices to allow for the optimal layout of data structures. This
 allows for multi-terabyte datasets to be held and manipulated in standard
 C++ data structures, whilst abstracting the complexity of managing this
 behaviour efficiently. STXXL utilises multi-disk I/O to speed up
 I/O bound calculations. STXXL has been developed at the University
 of Karlsruhe.
 .
 A benchmarking tool and STXXL on-disk file administration utility

=== debian/rules ===
#!/usr/bin/make -f
#location of stxxl's built-in jquery
JQUERY_STXXL_TARGET=/usr/share/doc/libstxxl-doc/html/html/jquery.js
#Location of debian jquery
JQUERY_SYS_TARGET=/usr/share/javascript/jquery/jquery.js
%:
	dh $@

override_dh_auto_install:
	dh_auto_install
	#Don't want this, so delete it
	rm -rf $$(pwd)/debian/tmp/usr/lib/cmake/
	
override_dh_install:
	dh_install
	#Relink jquery to system provided copy.
	rm -f $$(pwd)/debian/libstxxl-doc/$(JQUERY_STXXL_TARGET)
	mkdir -p $$(pwd)/debian/libstxxl-doc/$$(dirname $(JQUERY_STXXL_TARGET) )
	#Symlink to system value
	ln -s $(JQUERY_SYS_TARGET) $$(pwd)/debian/libstxxl-doc/$(JQUERY_STXXL_TARGET)

override_dh_auto_build:
	dh_auto_build
	#Build doxygen HTML docs
	cd doc && doxygen .
	#Build PDF from doxygen generated latex files
	#cd doc/latex && make
	
override_dh_auto_clean:
	dh_auto_clean
	rm -rf doc/html/ doc/latex/

=== debian/watch ===
version=4
http://sf.net/stxxl stxxl-([0-9].+[0-9])\.tar\.gz
